Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv_qck.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 2024)
@@ -2,7 +2,8 @@
    !!==============================================================================
    !!                       ***  MODULE  traadv_qck  ***
-   !! Ocean active tracers:  horizontal & vertical advective trend
+   !! Ocean tracers:  horizontal & vertical advective trend
    !!==============================================================================
    !! History :  3.0  !  2008-07  (G. Reffray)  Original code
+   !!            3.3  !  2010-05  (C.Ethe, G. Madec)  merge TRC-TRA + switch from velocity to transport
    !!----------------------------------------------------------------------
 
@@ -16,6 +17,6 @@
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce         ! ocean space and time domain
+   USE trdtra      ! ocean tracers trends 
    USE trabbl          ! advective term in the BBL
    USE lib_mpp         ! distribued memory computing
@@ -24,5 +25,4 @@
    USE in_out_manager  ! I/O manager
    USE diaptr          ! poleward transport diagnostics
-   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -31,6 +31,6 @@
    PUBLIC   tra_adv_qck   ! routine called by step.F90
 
-   REAL(wp), DIMENSION(jpi,jpj) ::   btr2
-   REAL(wp)                     ::   r1_6
+   REAL(wp)  ::   r1_6 = 1./ 6.
+   LOGICAL   :: l_trd    ! flag to compute trends
 
    !! * Substitutions
@@ -45,5 +45,6 @@
 CONTAINS
 
-   SUBROUTINE tra_adv_qck( kt, pun, pvn, pwn )
+   SUBROUTINE tra_adv_qck ( kt   , cdtype, pun  , pvn, pwn, &
+      &                     ptrab, ptran , ptraa, kjpt   )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_adv_qck  ***
@@ -69,5 +70,5 @@
       !!         dt = 2*rdtra and the scalar values are tb and sb
       !!
-      !!       On the vertical, the simple centered scheme used tn and sn
+      !!       On the vertical, the simple centered scheme used ptran
       !!
       !!               The fluxes are bounded by the ULTIMATE limiter to
@@ -75,20 +76,18 @@
       !!            prevent the appearance of spurious numerical oscillations
       !!
-      !! ** Action : - update (ta,sa) with the now advective tracer trends
-      !!             - save the trends ('key_trdtra')
+      !! ** Action : - update (ptraa) with the now advective tracer trends
+      !!             - save the trends 
       !!
       !! ** Reference : Leonard (1979, 1991)
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   ztrdt => ua   ! use ua as workspace
-      USE oce, ONLY :   ztrds => va   ! use va as workspace
-      !!
-      INTEGER , INTENT(in)                         ::  kt  ! ocean time-step index
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::  pun ! effective ocean velocity, u_component
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::  pvn ! effective ocean velocity, v_component
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::  pwn ! effective ocean velocity, w_component
-      !!
-      INTEGER  ::   ji, jj, jk                          ! dummy loop indices
-      REAL(wp) ::   z_hdivn_x, z_hdivn_y, z_hdivn       ! temporary scalars
-      REAL(wp) ::   zbtr, z2                            !    "         "
+      !!* Arguments
+      INTEGER         , INTENT(in   )                               ::   kt              ! ocean time-step index
+      CHARACTER(len=3), INTENT(in   )                               ::   cdtype          ! =TRA or TRC (tracer indicator)
+      INTEGER         , INTENT(in   )                               ::   kjpt            ! number of tracers
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk)       ::   pun, pvn, pwn   ! 3 ocean velocity components
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptrab, ptran        ! before and now tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptraa           ! tracer trend 
+      !!* Local declarations
+      REAL(wp) ::   z2                            !    temporary scalar
       !!----------------------------------------------------------------------
 
@@ -98,6 +97,7 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
          IF(lwp) WRITE(numout,*)
-         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
-         r1_6      = 1. / 6.
+         !
+         l_trd = .FALSE.
+         IF( ( cdtype == 'TRA' .AND. l_trdtra ) .OR. ( cdtype == 'TRC' .AND. l_trdtrc ) ) l_trd = .TRUE.
       ENDIF
 
